import java.io.BufferedWriter;
import java.io.FileWriter;
import java.io.PrintWriter;
import java.util.ArrayList;

/**
 * 汎用的なメソッドを扱うクラスです。
 * @author theki
 *
 */
public class Util {

	// 出力用配列
	public static StringBuilder[] output = null;
	// 出力ファイル名の配列
	private static ArrayList<String> outputFileNames = new ArrayList<String>();

	/**
	 * 文字列dataのnowPos+1の位置から、整数を取得して返します。
	 * 取得出来なかった場合、Integer.MAX_VALUEを返します。
	 * @param data 数字を取得する文字列
	 * @param nowPos　検索開始位置
	 * @return　取得した整数
	 */
	public static int getNextNum( String data, int nowPos ){
		if( data.length() == nowPos +1 ) 
			return Integer.MAX_VALUE ;
		int t = 0  ;
		int sign = 1 ;
		if( data.charAt(nowPos+1) == '-' ){
			sign = -1 ;
			nowPos ++ ;
		}
		if( data.charAt(nowPos+1) < '0' || data.charAt(nowPos+1) > '9' )
			return Integer.MAX_VALUE ;
		while(data.charAt(nowPos+1) >= '0' && data.charAt(nowPos+1) <= '9'){
			nowPos ++ ;
			t *= 10 ;
			t += (int)(data.charAt(nowPos)-'0') ;
			if( data.length() == nowPos +1 ) return t*sign ;
		}
		return t*sign ;
	}
	
	/**
	 * fileNameをファイル名とする出力用配列に対し、文字列outを追加します。
	 * このメソッドでは、実際のファイルの更新は行われません。
	 * @param out　出力文字列
	 * @param fileName　出力ファイル名
	 */
	public static void outputString( String out, String fileName ) {
//		System.out.print(out);
		if( !outputFileNames.contains(fileName))
			outputFileNames.add(fileName);
		int num = outputFileNames.indexOf(fileName) ;
		
		try{
			// output配列の初期化
			if( output == null ){
				output = new StringBuilder[1];
				output[0] = new StringBuilder() ;
				FileWriter fout = new FileWriter(outputFileNames.get(num));
				fout.close();
			}
			// output配列の拡張
			else if( num >= output.length ){
				StringBuilder[] temp = output ;
				output = new StringBuilder[num+1] ;
				for(int i=0;i<temp.length;i++)
					output[i] = temp[i] ;
				for(int i=temp.length;i<num+1;i++)
					output[i] = new StringBuilder() ;
				FileWriter fout = new FileWriter(outputFileNames.get(num));
				fout.close();
			}
			
			// 文字列を追加
			output[num].append(out);
			if(output[num].length()>99000)
				saveData(num) ;
			
		} catch(Exception e){
			System.out.println("【エラー発生！】エンターキーで終了します。");
			System.out.println(fileName+"が既に開かれており、編集が出来ません。");
			
			Simulation.exceptionExit();
		}
	}
	
	/**
	 * static変数outputに格納されている文字列を、それぞれのファイルに出力します。
	 */
	public static void saveData() {
		PrintWriter fout = null ;
		try{
			for(int j=0;j<output.length;j++){
				fout = new PrintWriter(new BufferedWriter(new  FileWriter(outputFileNames.get(j),true)));
				fout.print(output[j]);
				fout.close();
				output[j].delete(0, output[j].length());
			}
		} catch(Exception e) {
			e.printStackTrace();
		}
	}

	/**
	 * static変数outputのnum番目に格納されている文字列を、そのファイルに出力します。
	 * @throws Exception
	 */
	private static void saveData(int num) throws Exception{
		PrintWriter fout = null ;
		fout = new PrintWriter(new BufferedWriter(new  FileWriter(outputFileNames.get(num),true)));
		fout.print(output[num]);
		fout.close();
		output[num].delete(0, output[num].length());
	}

}
